"""autogenerated by genmsg_py from WalkPath.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import walk_msgs.msg
import nav_msgs.msg
import std_msgs.msg

class WalkPath(roslib.message.Message):
  _md5sum = "d0a0a99ccf67829c6bd2a9f0499ae76e"
  _type = "walk_msgs/WalkPath"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """nav_msgs/Path left_foot
nav_msgs/Path right_foot
walk_msgs/PathPoint3d center_of_mass
walk_msgs/PathPoint2d zmp

================================================================================
MSG: nav_msgs/Path
#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: walk_msgs/PathPoint3d
Header header
geometry_msgs/PointStamped[] points

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: walk_msgs/PathPoint2d
Header header
walk_msgs/Point2dStamped[] points

================================================================================
MSG: walk_msgs/Point2dStamped
Header header
Point2d point

================================================================================
MSG: walk_msgs/Point2d
float64 x
float64 y

"""
  __slots__ = ['left_foot','right_foot','center_of_mass','zmp']
  _slot_types = ['nav_msgs/Path','nav_msgs/Path','walk_msgs/PathPoint3d','walk_msgs/PathPoint2d']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       left_foot,right_foot,center_of_mass,zmp
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(WalkPath, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.left_foot is None:
        self.left_foot = nav_msgs.msg.Path()
      if self.right_foot is None:
        self.right_foot = nav_msgs.msg.Path()
      if self.center_of_mass is None:
        self.center_of_mass = walk_msgs.msg.PathPoint3d()
      if self.zmp is None:
        self.zmp = walk_msgs.msg.PathPoint2d()
    else:
      self.left_foot = nav_msgs.msg.Path()
      self.right_foot = nav_msgs.msg.Path()
      self.center_of_mass = walk_msgs.msg.PathPoint3d()
      self.zmp = walk_msgs.msg.PathPoint2d()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.left_foot.header.seq, _x.left_foot.header.stamp.secs, _x.left_foot.header.stamp.nsecs))
      _x = self.left_foot.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.left_foot.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.left_foot.poses:
        _v1 = val1.header
        buff.write(_struct_I.pack(_v1.seq))
        _v2 = _v1.stamp
        _x = _v2
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v1.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v3 = val1.pose
        _v4 = _v3.position
        _x = _v4
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v5 = _v3.orientation
        _x = _v5
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_3I.pack(_x.right_foot.header.seq, _x.right_foot.header.stamp.secs, _x.right_foot.header.stamp.nsecs))
      _x = self.right_foot.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.right_foot.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.right_foot.poses:
        _v6 = val1.header
        buff.write(_struct_I.pack(_v6.seq))
        _v7 = _v6.stamp
        _x = _v7
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v6.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v8 = val1.pose
        _v9 = _v8.position
        _x = _v9
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v10 = _v8.orientation
        _x = _v10
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_3I.pack(_x.center_of_mass.header.seq, _x.center_of_mass.header.stamp.secs, _x.center_of_mass.header.stamp.nsecs))
      _x = self.center_of_mass.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.center_of_mass.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.center_of_mass.points:
        _v11 = val1.header
        buff.write(_struct_I.pack(_v11.seq))
        _v12 = _v11.stamp
        _x = _v12
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v11.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v13 = val1.point
        _x = _v13
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_3I.pack(_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs))
      _x = self.zmp.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.zmp.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.zmp.points:
        _v14 = val1.header
        buff.write(_struct_I.pack(_v14.seq))
        _v15 = _v14.stamp
        _x = _v15
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v14.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v16 = val1.point
        _x = _v16
        buff.write(_struct_2d.pack(_x.x, _x.y))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.left_foot is None:
        self.left_foot = nav_msgs.msg.Path()
      if self.right_foot is None:
        self.right_foot = nav_msgs.msg.Path()
      if self.center_of_mass is None:
        self.center_of_mass = walk_msgs.msg.PathPoint3d()
      if self.zmp is None:
        self.zmp = walk_msgs.msg.PathPoint2d()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.left_foot.header.seq, _x.left_foot.header.stamp.secs, _x.left_foot.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.left_foot.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.left_foot.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v17 = val1.header
        start = end
        end += 4
        (_v17.seq,) = _struct_I.unpack(str[start:end])
        _v18 = _v17.stamp
        _x = _v18
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v17.frame_id = str[start:end]
        _v19 = val1.pose
        _v20 = _v19.position
        _x = _v20
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v21 = _v19.orientation
        _x = _v21
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.left_foot.poses.append(val1)
      _x = self
      start = end
      end += 12
      (_x.right_foot.header.seq, _x.right_foot.header.stamp.secs, _x.right_foot.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.right_foot.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.right_foot.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v22 = val1.header
        start = end
        end += 4
        (_v22.seq,) = _struct_I.unpack(str[start:end])
        _v23 = _v22.stamp
        _x = _v23
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v22.frame_id = str[start:end]
        _v24 = val1.pose
        _v25 = _v24.position
        _x = _v25
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v26 = _v24.orientation
        _x = _v26
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.right_foot.poses.append(val1)
      _x = self
      start = end
      end += 12
      (_x.center_of_mass.header.seq, _x.center_of_mass.header.stamp.secs, _x.center_of_mass.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.center_of_mass.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.center_of_mass.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PointStamped()
        _v27 = val1.header
        start = end
        end += 4
        (_v27.seq,) = _struct_I.unpack(str[start:end])
        _v28 = _v27.stamp
        _x = _v28
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v27.frame_id = str[start:end]
        _v29 = val1.point
        _x = _v29
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.center_of_mass.points.append(val1)
      _x = self
      start = end
      end += 12
      (_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.zmp.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.zmp.points = []
      for i in range(0, length):
        val1 = walk_msgs.msg.Point2dStamped()
        _v30 = val1.header
        start = end
        end += 4
        (_v30.seq,) = _struct_I.unpack(str[start:end])
        _v31 = _v30.stamp
        _x = _v31
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v30.frame_id = str[start:end]
        _v32 = val1.point
        _x = _v32
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        self.zmp.points.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.left_foot.header.seq, _x.left_foot.header.stamp.secs, _x.left_foot.header.stamp.nsecs))
      _x = self.left_foot.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.left_foot.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.left_foot.poses:
        _v33 = val1.header
        buff.write(_struct_I.pack(_v33.seq))
        _v34 = _v33.stamp
        _x = _v34
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v33.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v35 = val1.pose
        _v36 = _v35.position
        _x = _v36
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v37 = _v35.orientation
        _x = _v37
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_3I.pack(_x.right_foot.header.seq, _x.right_foot.header.stamp.secs, _x.right_foot.header.stamp.nsecs))
      _x = self.right_foot.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.right_foot.poses)
      buff.write(_struct_I.pack(length))
      for val1 in self.right_foot.poses:
        _v38 = val1.header
        buff.write(_struct_I.pack(_v38.seq))
        _v39 = _v38.stamp
        _x = _v39
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v38.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v40 = val1.pose
        _v41 = _v40.position
        _x = _v41
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v42 = _v40.orientation
        _x = _v42
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_3I.pack(_x.center_of_mass.header.seq, _x.center_of_mass.header.stamp.secs, _x.center_of_mass.header.stamp.nsecs))
      _x = self.center_of_mass.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.center_of_mass.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.center_of_mass.points:
        _v43 = val1.header
        buff.write(_struct_I.pack(_v43.seq))
        _v44 = _v43.stamp
        _x = _v44
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v43.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v45 = val1.point
        _x = _v45
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_3I.pack(_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs))
      _x = self.zmp.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.zmp.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.zmp.points:
        _v46 = val1.header
        buff.write(_struct_I.pack(_v46.seq))
        _v47 = _v46.stamp
        _x = _v47
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v46.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v48 = val1.point
        _x = _v48
        buff.write(_struct_2d.pack(_x.x, _x.y))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.left_foot is None:
        self.left_foot = nav_msgs.msg.Path()
      if self.right_foot is None:
        self.right_foot = nav_msgs.msg.Path()
      if self.center_of_mass is None:
        self.center_of_mass = walk_msgs.msg.PathPoint3d()
      if self.zmp is None:
        self.zmp = walk_msgs.msg.PathPoint2d()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.left_foot.header.seq, _x.left_foot.header.stamp.secs, _x.left_foot.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.left_foot.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.left_foot.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v49 = val1.header
        start = end
        end += 4
        (_v49.seq,) = _struct_I.unpack(str[start:end])
        _v50 = _v49.stamp
        _x = _v50
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v49.frame_id = str[start:end]
        _v51 = val1.pose
        _v52 = _v51.position
        _x = _v52
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v53 = _v51.orientation
        _x = _v53
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.left_foot.poses.append(val1)
      _x = self
      start = end
      end += 12
      (_x.right_foot.header.seq, _x.right_foot.header.stamp.secs, _x.right_foot.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.right_foot.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.right_foot.poses = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PoseStamped()
        _v54 = val1.header
        start = end
        end += 4
        (_v54.seq,) = _struct_I.unpack(str[start:end])
        _v55 = _v54.stamp
        _x = _v55
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v54.frame_id = str[start:end]
        _v56 = val1.pose
        _v57 = _v56.position
        _x = _v57
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v58 = _v56.orientation
        _x = _v58
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.right_foot.poses.append(val1)
      _x = self
      start = end
      end += 12
      (_x.center_of_mass.header.seq, _x.center_of_mass.header.stamp.secs, _x.center_of_mass.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.center_of_mass.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.center_of_mass.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.PointStamped()
        _v59 = val1.header
        start = end
        end += 4
        (_v59.seq,) = _struct_I.unpack(str[start:end])
        _v60 = _v59.stamp
        _x = _v60
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v59.frame_id = str[start:end]
        _v61 = val1.point
        _x = _v61
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.center_of_mass.points.append(val1)
      _x = self
      start = end
      end += 12
      (_x.zmp.header.seq, _x.zmp.header.stamp.secs, _x.zmp.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.zmp.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.zmp.points = []
      for i in range(0, length):
        val1 = walk_msgs.msg.Point2dStamped()
        _v62 = val1.header
        start = end
        end += 4
        (_v62.seq,) = _struct_I.unpack(str[start:end])
        _v63 = _v62.stamp
        _x = _v63
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v62.frame_id = str[start:end]
        _v64 = val1.point
        _x = _v64
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        self.zmp.points.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_2d = struct.Struct("<2d")
_struct_3I = struct.Struct("<3I")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
